Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp	(revision 123)
@@ -24,4 +24,6 @@
     log_function(Commit_unit,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     Tcontrol_t bank_full         [_param->_nb_bank];
     Tcontrol_t insert_ack        [_param->_nb_rename_unit][_param->_max_nb_inst_insert];
@@ -136,5 +138,15 @@
 #endif
 	}
-    
+      }    
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_bank; i++)
+          internal_BANK_INSERT_VAL  [i] = false;
+        for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+          for (uint32_t j=0; j<_param->_nb_inst_insert[i]; j++)
+            PORT_WRITE(out_INSERT_ACK       [i][j],0);
+
+      }
+
     log_end(Commit_unit,FUNCTION);
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 123)
@@ -24,4 +24,6 @@
     log_function(Commit_unit,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     Tcontrol_t retire_val          [_param->_nb_rename_unit][_param->_max_nb_inst_retire];
     uint32_t   num_inst_retire     [_param->_nb_rename_unit];
@@ -186,6 +188,6 @@
 
                   // if future event, don't update after this event
-                  if (reg_EVENT_STOP [front_end_id][context_id] and
-                      (reg_EVENT_PACKET [entry->front_end_id][entry->context_id]  == packet))
+                  if ((reg_EVENT_STATE  [entry->front_end_id][entry->context_id] == COMMIT_EVENT_STATE_NOT_YET_EVENT) and
+                      (reg_EVENT_PACKET [entry->front_end_id][entry->context_id] == packet))
                     bypass = false;
 	      }
@@ -211,4 +213,11 @@
 	  PORT_WRITE(out_SPR_WRITE_SR_OV     [i][j], spr_write_sr_ov     [i][j]);
 	}
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+          for (uint32_t j=0; j<_param->_nb_inst_retire[i]; j++)
+            PORT_WRITE(out_RETIRE_VAL [i][j],0);
+      }
 
     log_end(Commit_unit,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 123)
@@ -24,4 +24,6 @@
     log_function(Commit_unit,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     // ===================================================================
     // =====[ REEXECUTE ]=================================================
@@ -105,5 +107,4 @@
 
 	  internal_REEXECUTE_VAL      [i] = val;
-	  PORT_WRITE(out_REEXECUTE_VAL[i], internal_REEXECUTE_VAL [i]);
 	}
     }
@@ -148,5 +149,6 @@
 
                   // don't complete a branch when rob manage an present event
-		  if ((reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_NO_EVENT) and
+		  if (((reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_NO_EVENT) or
+                       (reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_NOT_YET_EVENT)) and
                       (state == ROB_BRANCH_COMPLETE))
 		    {
@@ -154,7 +156,7 @@
 
                       // test if have a future event (stop is set)
-                      log_printf(TRACE,Commit_unit,FUNCTION,"      * reg_EVENT_STOP   : %d",reg_EVENT_STOP [front_end_id][context_id]);
-
-                      if (reg_EVENT_STOP [front_end_id][context_id])
+//                       log_printf(TRACE,Commit_unit,FUNCTION,"      * reg_EVENT_STOP   : %d",reg_EVENT_STOP [front_end_id][context_id]);
+
+                      if (reg_EVENT_STATE [front_end_id][context_id] == COMMIT_EVENT_STATE_NOT_YET_EVENT)
                         {
                           // Have future event, can complete the branch if the event is most speculative than this branchement
@@ -204,5 +206,4 @@
 
 	  internal_BRANCH_COMPLETE_VAL [i] = val;
-	  PORT_WRITE(out_BRANCH_COMPLETE_VAL [i], internal_BRANCH_COMPLETE_VAL [i]);
 	}
     }
@@ -275,6 +276,4 @@
 	}
       
-      PORT_WRITE(out_UPDATE_VAL, internal_UPDATE_VAL);
-
       log_printf(TRACE,Commit_unit,FUNCTION,"  * UPDATE (end)");
     }
@@ -283,10 +282,22 @@
     // =====[ NB_INST ]===================================================
     // ===================================================================
-    for (uint32_t i=0; i<_param->_nb_front_end; i++)
-      for (uint32_t j=0; j<_param->_nb_context [i]; j++)
-	{
-	  PORT_WRITE(out_NB_INST_COMMIT_ALL [i][j], reg_NB_INST_COMMIT_ALL [i][j]);
-	  PORT_WRITE(out_NB_INST_COMMIT_MEM [i][j], reg_NB_INST_COMMIT_MEM [i][j]);
-	}
+    {
+#ifdef DEBUG_TEST
+      bool empty = true;
+#endif
+      for (uint32_t i=0; i<_param->_nb_front_end; i++)
+        for (uint32_t j=0; j<_param->_nb_context [i]; j++)
+          {
+#ifdef DEBUG_TEST
+            empty &= (reg_NB_INST_COMMIT_ALL [i][j] == 0);
+#endif
+            PORT_WRITE(out_NB_INST_COMMIT_ALL [i][j], reg_NB_INST_COMMIT_ALL [i][j]);
+            PORT_WRITE(out_NB_INST_COMMIT_MEM [i][j], reg_NB_INST_COMMIT_MEM [i][j]);
+          }
+#ifdef DEBUG_TEST
+      PORT_WRITE(out_INFO_ROB_EMPTY,empty);
+#endif
+    }
+
 
     // ===================================================================
@@ -296,14 +307,49 @@
       for (uint32_t j=0; j<_param->_nb_context [i]; j++)
         {
-//        bool flush = reg_EVENT_FLUSH [i][j];
-          bool flush = (((reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_EVENT) or
-                         (reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_WAIT_DECOD)) and
-                        not reg_EVENT_CAN_RESTART[i][j]);
+//           bool flush = (((reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_EVENT) or
+//                          (reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_WAIT_DECOD)) and
+//                         not reg_EVENT_CAN_RESTART[i][j]);
 
           PORT_WRITE(out_RETIRE_EVENT_STATE [i][j], commit_event_state_to_event_state(reg_EVENT_STATE[i][j]));
-          PORT_WRITE(out_RETIRE_EVENT_FLUSH [i][j], flush);
-          PORT_WRITE(out_RETIRE_EVENT_STOP  [i][j], reg_EVENT_STOP [i][j]);
+//        PORT_WRITE(out_RETIRE_EVENT_FLUSH [i][j], flush);
+//        PORT_WRITE(out_RETIRE_EVENT_STOP  [i][j], reg_EVENT_STOP [i][j]);
+          PORT_WRITE(out_RETIRE_EVENT_STOP  [i][j], ((reg_EVENT_STATE [i][j] == COMMIT_EVENT_STATE_NOT_YET_EVENT) or
+                                                     reg_EVENT_NEXT_STOP [i][j]));
         }
-
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_inst_reexecute; ++i)
+          {
+            internal_REEXECUTE_VAL      [i] = 0;
+//             internal_REEXECUTE_NUM_BANK [i] = num_bank;
+          }
+
+        for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+          {
+            internal_BRANCH_COMPLETE_VAL [i] = 0;
+//             internal_BRANCH_COMPLETE_NUM_BANK           [i] = num_bank;
+          }
+
+        internal_UPDATE_VAL = 0;
+//       internal_UPDATE_NUM_BANK = reg_NUM_BANK_HEAD;
+
+
+        for (uint32_t i=0; i<_param->_nb_front_end; i++)
+          for (uint32_t j=0; j<_param->_nb_context [i]; j++)
+            {
+              PORT_WRITE(out_RETIRE_EVENT_STATE [i][j], commit_event_state_to_event_state(COMMIT_EVENT_STATE_NO_EVENT));
+//            PORT_WRITE(out_RETIRE_EVENT_FLUSH [i][j], flush);
+//            PORT_WRITE(out_RETIRE_EVENT_STOP  [i][j], reg_EVENT_STOP [i][j]);
+              PORT_WRITE(out_RETIRE_EVENT_STOP  [i][j], true);
+            }
+      }
+
+      for (uint32_t i=0; i<_param->_nb_inst_reexecute; ++i)
+        PORT_WRITE(out_REEXECUTE_VAL[i], internal_REEXECUTE_VAL [i]);
+      for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+        PORT_WRITE(out_BRANCH_COMPLETE_VAL [i], internal_BRANCH_COMPLETE_VAL [i]);
+      PORT_WRITE(out_UPDATE_VAL, internal_UPDATE_VAL);
+        
     log_end(Commit_unit,FUNCTION);
   };
